/*************************************************
*           BK Emulator v3.8 for Windows         *
*************************************************/

/*
File: MultiEditListCtrl.cpp
Version: 1.0.0
Written by: Yuriy Kalmykov <kalmykov@stoik.com>
    Copyright (c) 2002-2004 Yuriy Kalmykov

    BK Emulator is a program emulated hardware environment for running
code for BK 0010(01) in different configurations.

    This code may be used in compiled form in any way you desire.
This file or it's parts can't be redistributed without the authors
written consent, but can be modified for your private needs.
    Providing that this notice and the authors name and all copyright
notices remains intact.

    Please, an email me to know how you are using it and where. You can
ask me for any information about this below code or any attendant
knowledge.

    This file is provided "as is" with no expressed or implied warranty.
The author accepts no liability for any damage or loss of business that
this product may cause.
*/


// MultiEditListCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "MultiEditListCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMultiEdit

CMultiEdit::CMultiEdit() : m_pListCtrl(NULL)
{
}

CMultiEdit::~CMultiEdit()
{
}

BEGIN_MESSAGE_MAP(CMultiEdit, CEdit)
	ON_WM_KILLFOCUS()
	ON_WM_KEYDOWN()
	ON_WM_CHAR()
END_MESSAGE_MAP()


void CMultiEdit::Attach(CMultiEditListCtrl *pListCtrl, int nItem, int nSubItem)
{
	m_pListCtrl = pListCtrl;
	m_nItem = nItem;
	m_nSubItem = nSubItem;
}


void CMultiEdit::OnKillFocus(CWnd *pNewWnd)
{
	CEdit::OnKillFocus(pNewWnd);
// если закомментировать эти строки, то можно будет редактировать сразу несколько элементов.
	SetItem();
	delete this;
}


void CMultiEdit::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	if (nChar == VK_RETURN)
	{
		SetItem();
		delete this;
		return;
	}

	CEdit::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CMultiEdit::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	if (nChar == VK_RETURN)
	{
		return; // запрет обработки по-умолчанию
	}

	//запрещаем цифры 8 и 9
	if (nChar == 0x38 || nChar == 0x39)
	{
		return;
	}

	CEdit::OnChar(nChar, nRepCnt, nFlags);
}


void CMultiEdit::SetItem()
{
	CString strText;
	GetWindowText(strText);
	NMLISTVIEW *pLVNotyfy = new NMLISTVIEW;
	ZeroMemory(pLVNotyfy, sizeof(NMLISTVIEW));
	pLVNotyfy->hdr.hwndFrom = *m_pListCtrl;
	pLVNotyfy->hdr.idFrom = m_pListCtrl->GetDlgCtrlID();
	pLVNotyfy->hdr.code = LVN_ITEMCHANGING;
	pLVNotyfy->iItem = m_nItem;
	pLVNotyfy->iSubItem = m_nSubItem;
	pLVNotyfy->lParam = reinterpret_cast<LPARAM>(&strText); //эту строку можно передавать вот так, потому что SendMessage ждёт, пока
	// функция, которая там принимает эту строку, обработает её, и не использует на неё указатели.
	CWnd *pParent = m_pListCtrl->GetParent();
	ASSERT(pParent);
	LRESULT bProtect = S_FALSE;

	if (pParent)
	{
		bProtect = pParent->SendMessage(WM_NOTIFY, pLVNotyfy->hdr.idFrom, reinterpret_cast<LPARAM>(pLVNotyfy));

		if (!bProtect)
		{
			pLVNotyfy->hdr.code = LVN_ITEMCHANGED;
			pParent->SendMessage(WM_NOTIFY, pLVNotyfy->hdr.idFrom, reinterpret_cast<LPARAM>(pLVNotyfy));
		}
	}

	delete pLVNotyfy;
}


/////////////////////////////////////////////////////////////////////////////
// CMultiEditListCtrl

CMultiEditListCtrl::CMultiEditListCtrl() : m_pEdit(NULL)
{
}

CMultiEditListCtrl::~CMultiEditListCtrl()
{
	ClearColorTable();
}


/////////////////////////////////////////////////////////////////////////////
// CMultiEditListCtrl message handlers

BEGIN_MESSAGE_MAP(CMultiEditListCtrl, CListCtrl)
	ON_NOTIFY_REFLECT_EX(NM_DBLCLK, OnDblclk)
	ON_NOTIFY_REFLECT(NM_CUSTOMDRAW, OnCustomDraw)
	ON_NOTIFY_REFLECT_EX(LVN_INSERTITEM, OnInsertitem)
	ON_NOTIFY_REFLECT_EX(LVN_DELETEITEM, OnDeleteitem)
	ON_NOTIFY_REFLECT_EX(LVN_DELETEALLITEMS, OnDeleteallitems)
END_MESSAGE_MAP()


void CMultiEditListCtrl::PreSubclassWindow()
{
	LOGFONT lfnt;
	GetFont()->GetLogFont(&lfnt);
	m_font.CreateFontIndirect(&lfnt);
	m_StdColor = GetSysColor(COLOR_BTNTEXT);
	m_StdBgColor = GetSysColor(COLOR_WINDOW);
	CListCtrl::PreSubclassWindow();
}


BOOL CMultiEditListCtrl::OnDblclk(NMHDR *pNMHDR, LRESULT *pResult)
{
	LVHITTESTINFO hti;
	// Get current click info (item, subitem, etc.)
	GetCursorPos(&hti.pt);
	ScreenToClient(&hti.pt);
	SubItemHitTest(&hti);

	if (hti.flags & LVHT_ONITEMLABEL && !(GetStyle() & LVS_EDITLABELS))
	{
		if (m_colorTable[hti.iItem][hti.iSubItem].bEditable)
		{
			m_colorTable[hti.iItem][hti.iSubItem].bEdited = TRUE;
			// If label click - create edit ctrl for item
			CRect rcSubItem;
			GetSubItemRect(hti.iItem, hti.iSubItem, LVIR_LABEL, rcSubItem);
			ClientToScreen(&rcSubItem);
			m_pEdit = new CMultiEdit;
			m_pEdit->CreateEx(0, _T("edit"), NULL, WS_VISIBLE | WS_POPUP | WS_BORDER | ES_WANTRETURN | ES_MULTILINE | ES_NUMBER, rcSubItem, this, 0);
			m_pEdit->SetFont(&m_font);
			m_pEdit->Attach(this, hti.iItem, hti.iSubItem);
			m_pEdit->SetWindowText(GetItemText(hti.iItem, hti.iSubItem));
			m_pEdit->SetFocus();
		}
	}

	*pResult = S_OK;
	return FALSE;
}

void CMultiEditListCtrl::SetEndEdit(int nItem, int nSubitem)
{
	m_colorTable[nItem][nSubitem].bEdited = FALSE;
}


void CMultiEditListCtrl::OnCustomDraw(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLVCUSTOMDRAW pCustomDraw = reinterpret_cast<LPNMLVCUSTOMDRAW>(pNMHDR);
	*pResult = S_OK;

	switch (pCustomDraw->nmcd.dwDrawStage)
	{
		case CDDS_PREPAINT:
			*pResult = CDRF_NOTIFYITEMDRAW;
			break;

		case CDDS_ITEMPREPAINT:
			*pResult = CDRF_NOTIFYSUBITEMDRAW;
			break;

		case CDDS_SUBITEM | CDDS_ITEMPREPAINT:
			pCustomDraw->clrText = m_colorTable[pCustomDraw->nmcd.dwItemSpec][pCustomDraw->iSubItem].clrText;
			pCustomDraw->clrTextBk = m_colorTable[pCustomDraw->nmcd.dwItemSpec][pCustomDraw->iSubItem].clrTextBk;
			*pResult = CDRF_NEWFONT;
			break;
	}
}


BOOL CMultiEditListCtrl::OnInsertitem(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMListView = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	int n = GetColumnNumber();
	m_colorTable.SetAtGrow(pNMListView->iItem, new ITEM_INFO [n]);

	for (int i = 0; i < n; ++i)
	{
		ITEM_INFO *p = &(m_colorTable[pNMListView->iItem][i]);
		p->clrText = m_StdColor;
		p->clrTextBk = m_StdBgColor;
	}

	*pResult = S_OK;
	return FALSE;
}


BOOL CMultiEditListCtrl::OnDeleteitem(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMListView = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	int nItemCount = GetItemCount();

	if (pNMListView->iItem < nItemCount)
	{
		if (pNMListView->iItem < m_colorTable.GetCount())
		{
			if (m_colorTable[pNMListView->iItem])
			{
				delete [] m_colorTable[pNMListView->iItem];
				m_colorTable[pNMListView->iItem] = NULL;
			}

			m_colorTable.RemoveAt(pNMListView->iItem);
		}
	}

	*pResult = S_OK;
	return FALSE;
}


BOOL CMultiEditListCtrl::OnDeleteallitems(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMListView = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	ClearColorTable();
	*pResult = S_OK;
	return FALSE;
}


void CMultiEditListCtrl::InitColorTable()
{
}


void CMultiEditListCtrl::ClearColorTable()
{
	for (int n = 0; n < m_colorTable.GetCount(); ++n)
	{
		if (m_colorTable[n])
		{
			delete [] m_colorTable[n];
			m_colorTable[n] = NULL;
		}
	}

	m_colorTable.RemoveAll();
}


int CMultiEditListCtrl::GetColumnNumber()
{
	return GetHeaderCtrl()->GetItemCount();
}


void CMultiEditListCtrl::EnableEdit(BOOL bEnable, int nItem, int nColumn)
{
	int nItemCount = GetItemCount();
	ASSERT(nItemCount - 1 >= nItem);

	if (nItemCount - 1 < nItem)
	{
		return;
	}

	int nColumnCount = GetColumnNumber();
	ASSERT(nColumnCount - 1 >= nColumn);

	if (nColumnCount - 1 < nColumn)
	{
		return;
	}

	m_colorTable[nItem][nColumn].bEditable = bEnable;
}


void CMultiEditListCtrl::EnableRowEdit(BOOL bEnable, int nRow)
{
	int nColumnCount = GetColumnNumber();

	for (int n = 0; n < nColumnCount; ++n)
	{
		EnableEdit(bEnable, nRow, n);
	}
}


void CMultiEditListCtrl::EnableColumnEdit(BOOL bEnable, int nColumn)
{
	int nRowCount = GetItemCount();

	for (int n = 0; n < nRowCount; ++n)
	{
		EnableEdit(bEnable, n, nColumn);
	}
}


void CMultiEditListCtrl::SetItemColor(COLORREF col, int nItem, int nColumn)
{
	int nItemCount = GetItemCount();
	ASSERT(nItemCount - 1 >= nItem);

	if (nItemCount - 1 < nItem)
	{
		return;
	}

	int nColumnCount = GetColumnNumber();
	ASSERT(nColumnCount - 1 >= nColumn);

	if (nColumnCount - 1 < nColumn)
	{
		return;
	}

	m_colorTable[nItem][nColumn].clrText = col;
}


void CMultiEditListCtrl::SetRowColor(COLORREF col, int nRow)
{
	int nColumnCount = GetColumnNumber();

	for (int n = 0; n < nColumnCount; ++n)
	{
		SetItemColor(col, nRow, n);
	}
}


void CMultiEditListCtrl::SetColumnColor(COLORREF col, int nColumn)
{
	int nRowCount = GetItemCount();

	for (int n = 0; n < nRowCount; ++n)
	{
		SetItemColor(col, n, nColumn);
	}
}


void CMultiEditListCtrl::SetItemBkColor(COLORREF col, int nItem, int nColumn)
{
	int nItemCount = GetItemCount();
	ASSERT(nItemCount - 1 >= nItem);

	if (nItemCount - 1 < nItem)
	{
		return;
	}

	int nColumnCount = GetColumnNumber();
	ASSERT(nColumnCount - 1 >= nColumn);

	if (nColumnCount - 1 < nColumn)
	{
		return;
	}

	m_colorTable[nItem][nColumn].clrTextBk = col;
}


void CMultiEditListCtrl::SetRowBkColor(COLORREF col, int nRow)
{
	int nColumnCount = GetColumnNumber();

	for (int n = 0; n < nColumnCount; ++n)
	{
		SetItemBkColor(col, nRow, n);
	}
}


void CMultiEditListCtrl::SetColumnBkColor(COLORREF col, int nColumn)
{
	int nRowCount = GetItemCount();

	for (int n = 0; n < nRowCount; ++n)
	{
		SetItemBkColor(col, n, nColumn);
	}
}


void CMultiEditListCtrl::SetItemWithModified(WORD word, int nItem, int nSubitem, BOOL bColored)
{
	DWORD nNewValue = (DWORD)word;
	ITEM_INFO *p = &(m_colorTable[nItem][nSubitem]);

	//если этот итем в данный момент редактируется, то ничего не делать
	if (p->bEdited)
	{
		return;
	}

	if (bColored)
	{
		//если значение изменилось
		if (p->nValue != nNewValue)
		{
			//выведем его красным цветом
			SetItemColor(MODIFIED_COLOR, nItem, nSubitem);
			p->bModified = TRUE; //и пометим, что оно изменилось
			p->nValue = nNewValue;
			SetItemText(nItem, nSubitem, WordToOctString(word));
		}
		//если не менялось, но в прошлый раз было выведено красным цветом
		else if (p->bModified)
		{
			//выведем его обычным цветом
			SetItemColor(m_StdColor, nItem, nSubitem);
			p->bModified = FALSE; //и пометим, что больше не нужно ничего рисовать, пока значение снова не изменится
			p->nValue = nNewValue;
			SetItemText(nItem, nSubitem, WordToOctString(word));
		}

		//иначе - вообще не надо ничего выводить.
	}
	else
	{
		//если значение изменилось
		if (p->nValue != nNewValue)
		{
			//выведем его обычным цветом
			SetItemColor(m_StdColor, nItem, nSubitem);
			p->bModified = FALSE;
			p->nValue = nNewValue;
			SetItemText(nItem, nSubitem, WordToOctString(word));
		}

		//если не менялось - не выводим ничего
	}
}

void CMultiEditListCtrl::SetItemWithModifiedASCII(CString &str, int nItem, int nSubitem)
{
//недостаток метода - если в строке изменился хоть байт - подсвечивается вся строка
	ITEM_INFO *p = &(m_colorTable[nItem][nSubitem]);

	//если этот итем в данный момент редактируется, то ничего не делать
	if (p->bEdited)
	{
		return;
	}

	if (GetItemText(nItem, nSubitem) != str)
	{
		//выведем его красным цветом
		SetItemColor(MODIFIED_COLOR, nItem, nSubitem);
		p->bModified = TRUE; //и пометим, что оно изменилось
		SetItemText(nItem, nSubitem, str);
	}
	//если не менялось, но в прошлый раз было выведено красным цветом
	else if (p->bModified)
	{
		//выведем его обычным цветом
		SetItemColor(m_StdColor, nItem, nSubitem);
		p->bModified = FALSE; //и пометим, что больше не нужно ничего рисовать, пока значение снова не изменится
		SetItemText(nItem, nSubitem, str);
	}

	//иначе - вообще не надо ничего выводить.
}
